(* rascl.ml -- Copyright  2006 by Matthew C. Gushee 
   This program is free software, released under the terms of the BSD
   license. See the file LICENSE for details. *)

module Dict = RasclDict
module Parser = RasclParser
module Lexer = RasclLexer
module ConfigObject = RasclObject

let read_config_file fname =
  if not (Sys.file_exists fname) then
    failwith ("Config file '" ^ fname ^ "' not found.");
  let ic =
    try open_in fname
    with _ -> failwith ("Failed to read config file " ^ fname) in
  let buf = Lexing.from_channel ic in
  Parser.config_dict Lexer.dict buf
